(function ($, Drupal, drupalSettings) {
  'use strict';
  Drupal.behaviors.zoom = {
    attach: function (context, settings) {
     $(document, context).once('zoom').each(function(element) {
      var original_urls = drupalSettings.imageFieldZoom.image_urls;
      $('.xzoom-container img.xzoom').each(function () {
        var imgWidth = $(this).width();
        var zoomWidth = imgWidth;
        var zoomWidth = imgWidth/2;
        var image_zoom_style = $(this).data('image-zoom-style');
        var image_position = $(this).data('image-position');
        var defaultscale = $(this).data('defaultscale');
        var scroll = $(this).data('scroll');
        var tint = $(this).data('tint');
        var preview_box_dimension = $(this).data('zoom-preview-dimension');
        var zoomAttr = {};
        if(image_zoom_style == 'background') {
          zoomAttr = {
            defaultScale:defaultscale,
            title: true,
            Xoffset: 15,
            position: 'inside',
            scroll: scroll
          };
        } else if(image_zoom_style == 'box') {
          if(image_position == 'inside') {
            zoomAttr = {
              defaultScale:defaultscale,
              position: 'lens',
              lensShape: 'box',
              bg:false,
              sourceClass: 'xzoom-hidden',
              tint: tint,
              scroll: scroll
            };
          } else {
            var zoomWidth = $(this).data('preview-width');
            var zoomHeight = $(this).data('preview-height');
            zoomAttr = {
              zoomWidth: zoomWidth,
              zoomHeight: zoomHeight,
              defaultScale:defaultscale,
              position: image_position,
              tint: tint,
              scroll: scroll
            };
          }
        } else {
          zoomAttr = {
            defaultScale:defaultscale,
            position: 'lens',
            lensShape: 'circle',
            sourceClass: 'xzoom-hidden',
            tint: tint,
            scroll: scroll
          };
        }
        $(this).once('init').xzoom(zoomAttr);
      });
    });
   }

 };
})(jQuery, Drupal, drupalSettings);